/*
 * HelpDialog.java
 *
 * Created on February 17, 2001, 12:09 AM
 */



/**
 *
 * @author  Chad
 * @version 
 */

import javax.swing.tree.*;
import java.awt.*;
import java.util.*;

public class HelpDialog extends javax.swing.JFrame {

    /** Creates new form HelpDialog */
    public HelpDialog(String t) {
        initComponents ();
        pack ();
        
        this.setTitle(t);
        
        numOfItems = 0;
        numVisible = 1;
        widths = new Hashtable();

        theRoot = new DefaultMutableTreeNode(new String("Help Topics"));
        model = new DefaultTreeModel(theRoot);
       
        topicsTree.setModel(model);
        
    }
    
    public HelpDialog() {
        initComponents ();
        pack ();
        
        this.setTitle("Help Topics");
        
        numOfItems = 0;
        numVisible = 1;
        widths = new Hashtable();

        theRoot = new DefaultMutableTreeNode(new String("Help Topics"));
        model = new DefaultTreeModel(theRoot);
       
        topicsTree.setModel(model);
        
    }
    
    public void addTopic(String topic, DefaultMutableTreeNode parent)
    {
        numOfItems++;
        model.insertNodeInto(new DefaultMutableTreeNode(topic), (MutableTreeNode)parent, parent.getChildCount());
/*        Enumeration e = parent.pathFromAncestorEnumeration(theRoot);
        int num;
        for(num = 1; e.hasMoreElements(); num++)
            e.nextElement();
        double x = (6 * topic.length()) + (22 * num);
        if(x > topicsTree.getWidth())
            topicsTree.setPreferredSize(new Dimension((int)x, (int)topicsTree.getPreferredSize().getHeight() - 15));
        
        double y = (topicsTree.getRowBounds(0).getHeight() + 2.8) * (numOfItems + 1);
        if(y > topicsTree.getHeight())
             topicsTree.setPreferredSize(new Dimension((int)topicsTree.getPreferredSize().getWidth(),(int)y));
*/
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () {//GEN-BEGIN:initComponents
        jPanel4 = new javax.swing.JPanel ();
        jPanel5 = new javax.swing.JPanel ();
        jScrollPane1 = new javax.swing.JScrollPane ();
        topicsTree = new javax.swing.JTree ();
        jScrollPane2 = new javax.swing.JScrollPane ();
        jPanel1 = new javax.swing.JPanel ();
        jTextArea1 = new javax.swing.JTextArea ();
        getContentPane ().setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints1;
        setResizable (false);
        addWindowListener (new java.awt.event.WindowAdapter () {
            public void windowClosing (java.awt.event.WindowEvent evt) {
                exitForm (evt);
            }
        }
        );

        jPanel4.setLayout (new java.awt.FlowLayout (0, 3, 3));
        jPanel4.setPreferredSize (new java.awt.Dimension(395, 435));

          jPanel5.setLayout (new java.awt.FlowLayout (0, 3, 3));
          jPanel5.setPreferredSize (new java.awt.Dimension(398, 435));
  
            jScrollPane1.setPreferredSize (new java.awt.Dimension(130, 420));
            jScrollPane1.setMinimumSize (new java.awt.Dimension(130, 420));
    
              topicsTree.setPreferredSize (new java.awt.Dimension(120, 410));
              topicsTree.setAutoscrolls (true);
              topicsTree.addTreeExpansionListener (new javax.swing.event.TreeExpansionListener () {
                  public void treeExpanded (javax.swing.event.TreeExpansionEvent evt) {
                      topicsTreeTreeExpanded (evt);
                  }
                  public void treeCollapsed (javax.swing.event.TreeExpansionEvent evt) {
                      topicsTreeTreeCollapsed (evt);
                  }
              }
              );
      
              jScrollPane1.setViewportView (topicsTree);
      
            jPanel5.add (jScrollPane1);
    
            jScrollPane2.setPreferredSize (new java.awt.Dimension(248, 420));
    
              jPanel1.setLayout (new java.awt.FlowLayout (0, 0, 0));
              jPanel1.setPreferredSize (new java.awt.Dimension(248, 420));
              jPanel1.setAutoscrolls (true);
      
                jTextArea1.setPreferredSize (new java.awt.Dimension(248, 420));
        
                jPanel1.add (jTextArea1);
        
              jScrollPane2.setViewportView (jPanel1);
      
            jPanel5.add (jScrollPane2);
    
          jPanel4.add (jPanel5);
  

        gridBagConstraints1 = new java.awt.GridBagConstraints ();
        getContentPane ().add (jPanel4, gridBagConstraints1);

    }//GEN-END:initComponents

  private void topicsTreeTreeCollapsed (javax.swing.event.TreeExpansionEvent evt) {//GEN-FIRST:event_topicsTreeTreeCollapsed
// Add your handling code here:
    double size = 110;

    widths.remove(evt.getPath());
    Enumeration e = widths.elements();

    while(e.hasMoreElements())
    {
        double x = ((Double)e.nextElement()).doubleValue();
        if(x > size)
            size = x;
    }
    
    DefaultMutableTreeNode n = (DefaultMutableTreeNode)evt.getPath().getLastPathComponent();
    Enumeration e2 = n.children();
    while(e2.hasMoreElements())
    {
        numVisible--;
        e2.nextElement();
    }
    
    if(numVisible > 21)
    {
        int h = numVisible * 20 + 10;
        
        topicsTree.setPreferredSize(new Dimension((int)size, h));
    }
    else
    {
        topicsTree.setPreferredSize(new Dimension((int)size, 405));
    }
        
  }//GEN-LAST:event_topicsTreeTreeCollapsed

  private void topicsTreeTreeExpanded (javax.swing.event.TreeExpansionEvent evt) {//GEN-FIRST:event_topicsTreeTreeExpanded
// Add your handling code here:
        boolean exit = false;
        double finalSize = topicsTree.getPathBounds(evt.getPath()).getX() + 30;
        double size = 0;

        DefaultMutableTreeNode n = (DefaultMutableTreeNode)evt.getPath().getLastPathComponent();
        Enumeration e = n.children();
        while(e.hasMoreElements())
        {
            numVisible++;
            DefaultMutableTreeNode c = (DefaultMutableTreeNode)e.nextElement();
            if(c.toString().length() * 6 > size)
                size = c.toString().length() * 6;
        }
        finalSize += size;
        widths.put(evt.getPath(), new Double(finalSize));
        if(finalSize > topicsTree.getPreferredSize().getWidth() - 15)
        {
            topicsTree.setPreferredSize(new Dimension((int)finalSize, (int)topicsTree.getPreferredSize().getHeight()));
            
            int h = numVisible * 20 + 10;
        
            if(h > topicsTree.getPreferredSize().getHeight())
                topicsTree.setPreferredSize(new Dimension((int)topicsTree.getPreferredSize().getWidth(),h));
        }
        else
        {
            int h = numVisible * 20 + 10;
        
            if(h > topicsTree.getPreferredSize().getHeight())
                topicsTree.setPreferredSize(new Dimension((int)topicsTree.getPreferredSize().getWidth() -15,h));
        }
  }//GEN-LAST:event_topicsTreeTreeExpanded

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        if(!dialog){}
//            System.exit(0);
        else
            setVisible(false);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        //dialog = false;
        new HelpDialog ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree topicsTree;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
    
    private boolean dialog = false;
    private DefaultTreeModel model;
    private DefaultMutableTreeNode theRoot;
    private int numOfItems;
    private int numVisible;
    private Hashtable widths;
}