/*
 * SubmissionUtility.java
 *
 * Created on March 1, 2001, 3:17 PM
 */



/**
 *
 * @author  root
 * @version 
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import sun.net.ftp.*;
import java.util.zip.*;

public class SubmissionUtility extends javax.swing.JFrame {

    /** Creates new form SubmissionUtility */
    public SubmissionUtility() {
        initComponents ();
        pack ();
        this.setLocation(50, 50);
        
        Component temp;
        
        temp = ((JPanel)theFiles.getComponent(1)).getComponent(3);
        ((JComboBox)temp).setPreferredSize(new Dimension(163, 25));
        ((JComboBox)temp).setFont(new Font("Courier", Font.PLAIN, 12));
        
        
        localFiles.add(temp);
        localFiles.add(((JPanel)theFiles.getComponent(1)).getComponent(4));
        
        temp = theFiles.getComponent(3);
        ((JPanel)temp).setPreferredSize(new Dimension(190, 223));
        localFiles.add(temp);
        
        theFiles.setMultiSelectionEnabled(true);
        submitFilesLB.setSelectionMode(2);
        
        try
        {
            ObjectInputStream in = new ObjectInputStream(new FileInputStream("settings.asu"));
            curSettings = (ASUOptions)in.readObject();
            pref.names = (Vector)in.readObject();
            pref.settings = (Vector)in.readObject();
            
            setSettings(curSettings);
            
            pref.SetListData();
            
            for(int i = 0; i < pref.names.size(); i++)
            {
                if(curSettings.name == pref.names.elementAt(i))
                {   
                    pref.SetSelections(true, i);
                    break;
                }
                else if(i == pref.names.size()-1)
                {
                    pref.SetSelections(false, 0);
                    pref.SetCustomDisplay(curSettings);
                }
            }
            
            in.close();
        }
        catch(Exception e){}
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () {//GEN-BEGIN:initComponents
        jMenuBar1 = new javax.swing.JMenuBar ();
        fileMenu = new javax.swing.JMenu ();
        exitMI = new javax.swing.JMenuItem ();
        editMenu = new javax.swing.JMenu ();
        preferencesMI = new javax.swing.JMenuItem ();
        helpMenu = new javax.swing.JMenu ();
        contentsMI = new javax.swing.JMenuItem ();
        aboutMI = new javax.swing.JMenuItem ();
        jPanel1 = new javax.swing.JPanel ();
        jPanel5 = new javax.swing.JPanel ();
        jPanel7 = new javax.swing.JPanel ();
        jLabel1 = new javax.swing.JLabel ();
        nameTF = new javax.swing.JTextField ();
        jLabel2 = new javax.swing.JLabel ();
        jLabel3 = new javax.swing.JLabel ();
        assignCB = new javax.swing.JComboBox ();
        jPanel2 = new javax.swing.JPanel ();
        localFiles = new javax.swing.JPanel ();
        jPanel6 = new javax.swing.JPanel ();
        bAdd = new javax.swing.JButton ();
        bRemove = new javax.swing.JButton ();
        submitFilesSP = new javax.swing.JScrollPane ();
        submitFilesLB = new javax.swing.JList ();
        jPanel3 = new javax.swing.JPanel ();
        jPanel4 = new javax.swing.JPanel ();
        bSubmit = new javax.swing.JButton ();

          fileMenu.setFont (new java.awt.Font ("Courier", 0, 12));
          fileMenu.setText ("File");
  
            exitMI.setFont (new java.awt.Font ("Courier", 0, 12));
            exitMI.setText ("Exit");
            exitMI.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                    exitMIMousePressed (evt);
                }
            }
            );
    
            fileMenu.add (exitMI);
          jMenuBar1.add (fileMenu);
          editMenu.setFont (new java.awt.Font ("Courier", 0, 12));
          editMenu.setText ("Edit");
  
            preferencesMI.setFont (new java.awt.Font ("Courier", 0, 12));
            preferencesMI.setText ("Preferences");
            preferencesMI.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                    preferencesMIMousePressed (evt);
                }
            }
            );
    
            editMenu.add (preferencesMI);
          jMenuBar1.add (editMenu);
          helpMenu.setFont (new java.awt.Font ("Courier", 0, 12));
          helpMenu.setText ("Help");
  
            contentsMI.setFont (new java.awt.Font ("Courier", 0, 12));
            contentsMI.setText ("Contents");
            contentsMI.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                    contentsMIMousePressed (evt);
                }
            }
            );
    
            helpMenu.add (contentsMI);
            aboutMI.setFont (new java.awt.Font ("Courier", 0, 12));
            aboutMI.setText ("About ASU");
            aboutMI.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                    aboutMIMousePressed (evt);
                }
            }
            );
    
            helpMenu.add (aboutMI);
          jMenuBar1.add (helpMenu);
        getContentPane ().setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints1;
        setTitle ("Assignment Submission Utility");
        setResizable (false);
        addWindowListener (new java.awt.event.WindowAdapter () {
            public void windowClosing (java.awt.event.WindowEvent evt) {
                exitForm (evt);
            }
        }
        );

        jPanel1.setLayout (new java.awt.FlowLayout (0, 5, 2));
        jPanel1.setPreferredSize (new java.awt.Dimension(430, 370));

          jPanel5.setPreferredSize (new java.awt.Dimension(10, 4));
          jPanel5.setMinimumSize (new java.awt.Dimension(10, 5));
  
    
            jPanel5.add (jPanel7);
    
          jPanel1.add (jPanel5);
  
          jLabel1.setPreferredSize (new java.awt.Dimension(440, 12));
          jLabel1.setText ("Name");
          jLabel1.setFont (new java.awt.Font ("Courier", 0, 12));
  
          jPanel1.add (jLabel1);
  
          nameTF.setPreferredSize (new java.awt.Dimension(150, 20));
          nameTF.setFont (new java.awt.Font ("Courier", 0, 12));
  
          jPanel1.add (nameTF);
  
          jLabel2.setPreferredSize (new java.awt.Dimension(65, 16));
  
          jPanel1.add (jLabel2);
  
          jLabel3.setPreferredSize (new java.awt.Dimension(80, 20));
          jLabel3.setText ("Assignment");
          jLabel3.setFont (new java.awt.Font ("Courier", 0, 12));
  
          jPanel1.add (jLabel3);
  
          assignCB.setPreferredSize (new java.awt.Dimension(50, 20));
          assignCB.setFont (new java.awt.Font ("Courier", 0, 12));
          assignCB.setMaximumSize (new java.awt.Dimension(200, 26));
  
          jPanel1.add (assignCB);
  
          jPanel2.setPreferredSize (new java.awt.Dimension(380, 10));
  
          jPanel1.add (jPanel2);
  
          localFiles.setLayout (new java.awt.FlowLayout (1, 1, 1));
          localFiles.setPreferredSize (new java.awt.Dimension(190, 250));
  
          jPanel1.add (localFiles);
  
          jPanel6.setPreferredSize (new java.awt.Dimension(25, 75));
  
            bAdd.setFont (new java.awt.Font ("Dialog", 0, 14));
            bAdd.setText ("->");
            bAdd.setMargin (new java.awt.Insets(2, 2, 2, 2));
            bAdd.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                    bAddMousePressed (evt);
                }
            }
            );
    
            jPanel6.add (bAdd);
    
            bRemove.setFont (new java.awt.Font ("Dialog", 0, 14));
            bRemove.setText ("<-");
            bRemove.setMargin (new java.awt.Insets(2, 2, 2, 2));
            bRemove.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                    bRemoveMousePressed (evt);
                }
            }
            );
    
            jPanel6.add (bRemove);
    
          jPanel1.add (jPanel6);
  
          submitFilesSP.setPreferredSize (new java.awt.Dimension(190, 250));
  
            submitFilesLB.setFont (new java.awt.Font ("Courier", 0, 12));
    
            submitFilesSP.setViewportView (submitFilesLB);
    
          jPanel1.add (submitFilesSP);
  
          jPanel3.setPreferredSize (new java.awt.Dimension(380, 12));
  
          jPanel1.add (jPanel3);
  
          jPanel4.setPreferredSize (new java.awt.Dimension(410, 40));
  
            bSubmit.setLabel ("Submit");
            bSubmit.setFont (new java.awt.Font ("Courier", 0, 12));
            bSubmit.addMouseListener (new java.awt.event.MouseAdapter () {
                public void mousePressed (java.awt.event.MouseEvent evt) {
                    bSubmitMousePressed (evt);
                }
            }
            );
    
            jPanel4.add (bSubmit);
    
          jPanel1.add (jPanel4);
  

        gridBagConstraints1 = new java.awt.GridBagConstraints ();
        getContentPane ().add (jPanel1, gridBagConstraints1);

        setJMenuBar (jMenuBar1);

    }//GEN-END:initComponents

  private void bSubmitMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_bSubmitMousePressed
// Add your handling code here:    
    try{
        String sendName = new String();
    
        Date now = new Date();
    
        sendName = nameTF.getText();
        StringTokenizer tok = new StringTokenizer(sendName);
    
        sendName = tok.nextToken();
        while(tok.hasMoreTokens())
        {
            sendName += "_";
            sendName += tok.nextToken();
        }
    
        sendName += "_A" + (String)assignCB.getSelectedItem();
        sendName += "_";
    
        String temp = now.toString();
        tok = new StringTokenizer(temp);
        tok.nextToken();
    
        sendName += (tok.nextToken() + tok.nextToken() + "_");
    
        sendName += (new Integer(now.getHours())).toString();
        sendName += "-" + (new Integer(now.getMinutes())).toString();
        sendName += "-" + (new Integer(now.getSeconds())).toString();
    
        tok.nextToken();
        tok.nextToken();
        sendName += "_" + tok.nextToken() + ".zip";
    
        try {
        
            ZipOutputStream zout = new ZipOutputStream(new FileOutputStream(sendName));
            File sendFile = new File(sendName);
            Enumeration enumFiles = files.elements();
            while(enumFiles.hasMoreElements())
            {
                File current = (File)enumFiles.nextElement();
                BufferedInputStream bin = new BufferedInputStream(new FileInputStream(current.toString()));
                ZipEntry theEntry = new ZipEntry(current.getName());
                zout.putNextEntry(theEntry);
                byte [] data = new byte[1024];
                int bCnt;
                while((bCnt = bin.read(data)) != -1)
                    zout.write(data, 0, bCnt);
            
                zout.flush();
                zout.closeEntry();
                bin.close();
            }
        
            zout.close();

               
            FtpClient ftp = new FtpClient(curSettings.host);

            ftp.login(curSettings.user, curSettings.password);

            ftp.binary();
        
            if(curSettings.path != null)
                ftp.cd(curSettings.path);
        
            OutputStream os = ftp.put(sendName);
            BufferedOutputStream out = new BufferedOutputStream(os);
        
            InputStream is = new FileInputStream(sendFile);
            BufferedInputStream in = new BufferedInputStream(is);
        
            byte [] buffer = new byte[1024];
            int bCnt;
        
            while( (bCnt = in.read(buffer)) > 0)
            {
                out.write(buffer, 0, bCnt);
            }
            out.close();
            in.close();
        
            JOptionPane success = new JOptionPane();
            success.showMessageDialog(this, "The assignment was submitted successfully", "Submission Complete", JOptionPane.INFORMATION_MESSAGE);
        
            sendFile.delete();
        }    
        catch(Exception e) {
            JOptionPane error = new JOptionPane();
            error.showMessageDialog(this, e.toString() + "\nThe assignment was not submitted successfully",
                                        "An error has occured", JOptionPane.ERROR_MESSAGE);
        }
    
        File sendFile = new File(sendName);
        sendFile.delete();
    }
    catch(Exception e){}
  }//GEN-LAST:event_bSubmitMousePressed

  private void bRemoveMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_bRemoveMousePressed
// Add your handling code here:
    int [] num = submitFilesLB.getSelectedIndices();
    
    try{
        for(int i = num.length-1; i >= 0; i--)
        {
            submitFiles.remove(num[i]);
            files.remove(num[i]);
        }
        
        submitFilesLB.setListData(submitFiles);
//        submitFilesLB.repaint();    
    }
    catch(Exception e){}
  }//GEN-LAST:event_bRemoveMousePressed

  private void bAddMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_bAddMousePressed
// Add your handling code here:
    try{
        File [] newFiles = theFiles.getSelectedFiles();
        
        for(int i = 0; i < newFiles.length; i++)
        {
            File newFile = newFiles[i];
            submitFiles.add(newFile.getName());
            files.add(newFile);
        }
        submitFilesLB.setListData(submitFiles);
    }
    catch(Exception e){}
  }//GEN-LAST:event_bAddMousePressed

  private void aboutMIMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_aboutMIMousePressed
// Add your handling code here:
    AboutDialog about = new AboutDialog(this, true);
    about.show();
  }//GEN-LAST:event_aboutMIMousePressed

  private void contentsMIMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_contentsMIMousePressed
// Add your handling code here:
    HelpDialog help = new HelpDialog("Contents");
    help.setLocation(100, 100);
    help.setVisible(true);
  }//GEN-LAST:event_contentsMIMousePressed

  private void preferencesMIMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_preferencesMIMousePressed
// Add your handling code here:   
    pref.show();
  }//GEN-LAST:event_preferencesMIMousePressed

  private void exitMIMousePressed (java.awt.event.MouseEvent evt) {//GEN-FIRST:event_exitMIMousePressed
// Add your handling code here:
    saveSettings();
    System.exit(0);
  }//GEN-LAST:event_exitMIMousePressed

  private void saveSettings()
  {
    try
    {
        ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("settings.asu"));
        out.writeObject(curSettings);
        out.writeObject(pref.names);
        out.writeObject(pref.settings);
        out.close();        
    }
    catch(Exception e){}
  }

  public void setSettings(ASUOptions newSettings)
  {
    curSettings = newSettings;
    
    assignCB.removeAllItems();
    
    for(int i = 1; i <= (new Integer(curSettings.assigns)).intValue(); i++)
        assignCB.addItem((new Integer(i)).toString());
    
    this.setTitle("Assignment Submission Utility - " + curSettings.name);
  }
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        saveSettings();
        System.exit (0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new SubmissionUtility ().show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem exitMI;
    private javax.swing.JMenu editMenu;
    private javax.swing.JMenuItem preferencesMI;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JMenuItem contentsMI;
    private javax.swing.JMenuItem aboutMI;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField nameTF;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JComboBox assignCB;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel localFiles;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JButton bAdd;
    private javax.swing.JButton bRemove;
    private javax.swing.JScrollPane submitFilesSP;
    private javax.swing.JList submitFilesLB;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JButton bSubmit;
    // End of variables declaration//GEN-END:variables

    private JFileChooser theFiles = new JFileChooser();
    private Vector submitFiles = new Vector();
    private Vector files = new Vector();
    private ASUOptions curSettings = new ASUOptions();
    private PrefDialog pref = new PrefDialog(this, true);
}